#ifndef XADMASTER_FUNCTIONS_H
#define XADMASTER_FUNCTIONS_H

/*  $Id: functions.h,v 1.1 2006/08/13 11:57:44 laire Exp $
    declarations and prototypes

    XAD library system for archive handling
    Copyright (C) 1998 and later by Dirk Stcker <soft@dstoecker.de>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* xadmaster.h is included without its public library prototypes, so we
 * can define them ourselves using xadMasterBaseP instead of xadMasterBase */
#define XAD_NO_PROTOTYPES 1
#include <xadmaster.h>

/* include all library-internal structures, including xadMasterBaseP */
#include <privdefs.h>

/************************************************************************
*                                                                       *
*    library accessable function                                        *
*                                                                       *
************************************************************************/

/*** BEGIN auto-generated section (INTERNAL MORPHOS) */
#include <proto/utility.h>
#include <proto/xadmaster.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#define PROTOHOOK(name) \
  xadINT32 name( \
  struct Hook * hook, \
  struct xadArchiveInfoP *ai, \
  struct xadHookParam * param)

#define FUNCHOOK(name) PROTOHOOK(name) {

#define ENDFUNC }

/* xadAddDiskEntry - clientfunc.c */
xadERROR LIBxadAddDiskEntryA(void);
#define FUNCxadAddDiskEntry xadERROR LIBxadAddDiskEntryA(void) { \
  struct xadDiskInfo *di = (struct xadDiskInfo *) REG_A0; \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A1; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A2; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadAddFileEntry - clientfunc.c */
xadERROR LIBxadAddFileEntryA(void);
#define FUNCxadAddFileEntry xadERROR LIBxadAddFileEntryA(void) { \
  struct xadFileInfo *fi = (struct xadFileInfo *) REG_A0; \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A1; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A2; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadAllocObject - objects.c */
xadPTR LIBxadAllocObjectA(void);
#define FUNCxadAllocObject xadPTR LIBxadAllocObjectA(void) { \
  xadUINT32 type = (xadUINT32 ) REG_D0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A0; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadAllocVec - objects.c */
xadPTR LIBxadAllocVec(void);
#define FUNCxadAllocVec xadPTR LIBxadAllocVec(void) { \
  xadSize size = (xadSize ) REG_D0; \
  xadUINT32 flags = (xadUINT32 ) REG_D1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6;

/* xadCalcCRC16 - crc.c */
xadUINT16 LIBxadCalcCRC16(void);
#define FUNCxadCalcCRC16 xadUINT16 LIBxadCalcCRC16(void) { \
  xadUINT16 id = (xadUINT16 ) REG_D0; \
  xadUINT16 init = (xadUINT16 ) REG_D1; \
  xadSize size = (xadSize ) REG_D2; \
  const xadUINT8 *buffer = (const xadUINT8 *) REG_A0; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6;

/* xadCalcCRC32 - crc.c */
xadUINT32 LIBxadCalcCRC32(void);
#define FUNCxadCalcCRC32 xadUINT32 LIBxadCalcCRC32(void) { \
  xadUINT32 id = (xadUINT32 ) REG_D0; \
  xadUINT32 init = (xadUINT32 ) REG_D1; \
  xadSize size = (xadSize ) REG_D2; \
  const xadUINT8 *buffer = (const xadUINT8 *) REG_A0; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6;

/* xadConvertDates - dates.c */
xadERROR LIBxadConvertDatesA(void);
#define FUNCxadConvertDates xadERROR LIBxadConvertDatesA(void) { \
  xadTAGPTR tags = (xadTAGPTR ) REG_A0; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadConvertName - filename.c */
xadSTRPTR LIBxadConvertNameA(void);
#define FUNCxadConvertName xadSTRPTR LIBxadConvertNameA(void) { \
  xadUINT32 charset = (xadUINT32 ) REG_D0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A0; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadConvertProtection - protection.c */
xadERROR LIBxadConvertProtectionA(void);
#define FUNCxadConvertProtection xadERROR LIBxadConvertProtectionA(void) { \
  xadTAGPTR tags = (xadTAGPTR ) REG_A0; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadCopyMem - copymem.c */
void LIBxadCopyMem(void);
#define FUNCxadCopyMem void LIBxadCopyMem(void) { \
  const void *s = (const void *) REG_A0; \
  xadPTR d = (xadPTR ) REG_A1; \
  xadSize size = (xadSize ) REG_D0;

/* xadDiskUnArc - diskunarc.c */
xadERROR LIBxadDiskUnArcA(void);
#define FUNCxadDiskUnArc xadERROR LIBxadDiskUnArcA(void) { \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadFileUnArc - fileunarc.c */
xadERROR LIBxadFileUnArcA(void);
#define FUNCxadFileUnArc xadERROR LIBxadFileUnArcA(void) { \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadFreeHookAccess - hook.c */
void LIBxadFreeHookAccessA(void);
#define FUNCxadFreeHookAccess void LIBxadFreeHookAccessA(void) { \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadFreeInfo - info.c */
void LIBxadFreeInfo(void);
#define FUNCxadFreeInfo void LIBxadFreeInfo(void) { \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A0; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6;

/* xadFreeObject - objects.c */
void LIBxadFreeObjectA(void);
#define FUNCxadFreeObject void LIBxadFreeObjectA(void) { \
  xadPTR object = (xadPTR ) REG_A0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6;

/* xadGetClientInfo - clientfunc.c */
struct xadClient * LIBxadGetClientInfo(void);
#define FUNCxadGetClientInfo struct xadClient * LIBxadGetClientInfo(void) { \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6;

/* xadGetDefaultName - filename.c */
xadSTRPTR LIBxadGetDefaultNameA(void);
#define FUNCxadGetDefaultName xadSTRPTR LIBxadGetDefaultNameA(void) { \
  xadTAGPTR tags = (xadTAGPTR ) REG_A0; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadGetDiskInfo - diskfile.c */
xadERROR LIBxadGetDiskInfoA(void);
#define FUNCxadGetDiskInfo xadERROR LIBxadGetDiskInfoA(void) { \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadGetErrorText - error.c */
xadSTRPTR LIBxadGetErrorText(void);
#define FUNCxadGetErrorText xadSTRPTR LIBxadGetErrorText(void) { \
  xadERROR errnum = (xadERROR ) REG_D0;

/* xadGetFilename - filename.c */
xadERROR LIBxadGetFilenameA(void);
#define FUNCxadGetFilename xadERROR LIBxadGetFilenameA(void) { \
  xadUINT32 buffersize = (xadUINT32 ) REG_D0; \
  xadSTRPTR buffer = (xadSTRPTR ) REG_A0; \
  const xadSTRING *path = (const xadSTRING *) REG_A1; \
  const xadSTRING *name = (const xadSTRING *) REG_A2; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A3; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadGetInfo - info.c */
xadERROR LIBxadGetInfoA(void);
#define FUNCxadGetInfo xadERROR LIBxadGetInfoA(void) { \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6;

/* xadGetHookAccess - hook.c */
xadERROR LIBxadGetHookAccessA(void);
#define FUNCxadGetHookAccess xadERROR LIBxadGetHookAccessA(void) { \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadGetSystemInfo - info.c */
struct xadSystemInfo * LIBxadGetSystemInfo(void);
#define FUNCxadGetSystemInfo struct xadSystemInfo * LIBxadGetSystemInfo(void) { \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6;

/* xadHookAccess - clientfunc.c */
xadERROR LIBxadHookAccess(void);
#define FUNCxadHookAccess xadERROR LIBxadHookAccess(void) { \
  xadUINT32 command = (xadUINT32 ) REG_D0; \
  xadSignSize data = (xadSignSize ) REG_D1; \
  xadPTR buffer = (xadPTR ) REG_A0; \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6;

/* xadHookTagAccess - clientfunc.c */
xadERROR LIBxadHookTagAccessA(void);
#define FUNCxadHookTagAccess xadERROR LIBxadHookTagAccessA(void) { \
  xadUINT32 command = (xadUINT32 ) REG_D0; \
  xadSignSize data = (xadSignSize ) REG_D1; \
  xadPTR buffer = (xadPTR ) REG_A0; \
  struct xadArchiveInfoP *ai = (struct xadArchiveInfoP *) REG_A1; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A2; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/* xadRecogFile - info.c */
struct xadClient * LIBxadRecogFileA(void);
#define FUNCxadRecogFile struct xadClient * LIBxadRecogFileA(void) { \
  xadSize size = (xadSize ) REG_D0; \
  const void *mem = (const void *) REG_A0; \
  xadTAGPTR tags = (xadTAGPTR ) REG_A1; \
  struct xadMasterBaseP *xadMasterBase = (struct xadMasterBaseP *) REG_A6; \
  struct UtilityBase *UtilityBase = xadMasterBase->xmb_UtilityBase;

/*** END auto-generated section */

PROTOHOOK(InHookFH);       /* hook_fh.c */
PROTOHOOK(OutHookFH);      /* hook_fh.c */
PROTOHOOK(InHookMem);      /* hook_mem.c */
PROTOHOOK(OutHookMem);     /* hook_mem.c */
PROTOHOOK(InHookStream);   /* hook_stream.c */
PROTOHOOK(OutHookStream);  /* hook_stream.c */
PROTOHOOK(InHookDisk);     /* hook_disk.c */
PROTOHOOK(OutHookDisk);    /* hook_disk.c */
PROTOHOOK(InHookSplitted); /* hook_splitted.c */
PROTOHOOK(InHookDiskArc);  /* hook_diskarc.c */

/* clientfunc.c */
xadUINT32 callprogress(
                const struct xadArchiveInfoP *ai,
                xadUINT32 stat, xadUINT32 mode,
                struct xadMasterBaseP *xadMasterBase);

xadUINT32 callprogressFN(
                const struct xadArchiveInfoP *ai,
                xadUINT32 stat, xadUINT32 mode, xadSTRPTR *filename,
                struct xadMasterBaseP *xadMasterBase);

xadSignSize getskipsize(
                xadSignSize data,
                const struct xadArchiveInfoP *ai);

xadBOOL xadAddClients(struct xadMasterBaseP *xadMasterBase,
                      const struct xadClient *clients,
                      xadUINT32 add_flags);

void xadFreeClients(struct xadMasterBaseP *xadMasterBase);

void MakeCRC16(xadUINT16 *buf, xadUINT16 ID);
void MakeCRC32(xadUINT32 *buf, xadUINT32 ID);

extern const struct xadClient * const RealFirstClient;

#ifdef DEBUG
void DebugFlagged(xadUINT32 flags, const xadSTRING *fmt, ...);

void DebugTagList(const xadSTRING *, xadTAGPTR, ...);           /* print with 'R' and tags with 'T' */
void DebugTagListOther(const xadSTRING *, xadTAGPTR, ...);      /* print with 'O' and tags with 'T' */
void DebugTagListMem(const xadSTRING *, xadTAGPTR, ...);        /* print with 'R' or 'M' and tags with 'T' */
void DebugError(const xadSTRING *, ...);                        /* print with 'E' */
void DebugHook(const xadSTRING *, ...);                         /* print with 'H' */
void DebugHookTagList(const xadSTRING *, xadTAGPTR, ...);       /* print with 'H' and tags with 'T' */
void DebugRunTime(const xadSTRING *, ...);                      /* print with 'R' */
void DebugOther(const xadSTRING *, ...);                        /* print with 'O' */
void DebugMem(const xadSTRING *, ...);                          /* print with 'M' */
void DebugMemError(const xadSTRING *, ...);                     /* print with 'M' or 'E' */
void DebugFileSearched(const struct xadArchiveInfo *ai, const xadSTRING *, ...); /* print with 'D' */
void DebugClient(const struct xadArchiveInfo *ai, const xadSTRING *, ...);       /* print with 'D' */
#endif
#ifdef DEBUGRESOURCE
#define XADOBJCOOKIE 0x58414494
void DebugResource(struct xadMasterBaseP *, const xadSTRING *, ...);       /* print with 'C' */
/* called with 0 does end result check for this task */
/* called with 1 does end result check for all tasks */
#endif
#if defined(DEBUG) || defined(DEBUGRESOURCE)
#define DEBUGFLAG_ERROR         (1<<0)
#define DEBUGFLAG_RUNTIME       (1<<1)
#define DEBUGFLAG_TAGLIST       (1<<2)
#define DEBUGFLAG_HOOK          (1<<3)
#define DEBUGFLAG_OTHER         (1<<4)
#define DEBUGFLAG_MEM           (1<<5)
#define DEBUGFLAG_FLAGS         (1<<6)
#define DEBUGFLAG_RESOURCE      (1<<7)
#define DEBUGFLAG_CLIENT        (1<<8)
#define DEBUGFLAG_SEARCHED      (1<<9)
#define DEBUGFLAG_STATIC        (1<<10)
#define DEBUGFLAG_CONTINUESTART (1<<11)
#define DEBUGFLAG_CONTINUE      (1<<12)
#define DEBUGFLAG_CONTINUEEND   (1<<13)

extern struct ExecBase * SysBase;
extern struct DosLibrary * DOSBase;
extern struct UtilityBase * UtilityBase;
extern struct xadMasterBase * xadMasterBase;

xadSTRPTR xadGetObjectTypeName(xadUINT32 type); /* objects.c */
#endif

#endif /* XADMASTER_FUNCTIONS_H */
